//
//  LGOMModel.h
//  LifeGameOnMac
//
//  Created by narita on 2016/08/31.
//  Copyright © 2016年 narita. All rights reserved.
//

#import <Foundation/Foundation.h>

typedef struct LGOMPoint
{
    NSInteger x;
    NSInteger y;
} LGOMPoint;

typedef struct LGOMSize
{
    NSInteger width;
    NSInteger height;
} LGOMSize;

typedef struct LGOMRect
{
    LGOMPoint origine;
    LGOMSize  size;
} LGOMRect;

@interface LGOMModel : NSObject

#pragma mark -
#pragma mark class methods

+ (nullable instancetype) modelWithSize:(LGOMSize)inSize;

#pragma mark -
#pragma mark init methods

- (nullable instancetype) initWithSize:(LGOMSize)inSize NS_DESIGNATED_INITIALIZER;

- (nullable instancetype) init NS_UNAVAILABLE;

#pragma mark -
#pragma mark dealloc

#pragma mark -
#pragma mark NSCopying, hash, isEqual:

#pragma mark -
#pragma mark NSCoding methods

#pragma mark -
#pragma mark awakeFromNib-like methods

#pragma mark -
#pragma mark action methods

- (void) clearAll;
- (void) randomizeAll;

- (BOOL) aliveAtPoint:(LGOMPoint)inPoint;
- (void) setAlive:(BOOL)inAlive atPoint:(LGOMPoint)inPoint;

- (void) next;

- (NSInteger) sumAliveNeighborCellsAtPoint:(LGOMPoint)inPoint;

#pragma mark -
#pragma mark delegate/datasource methods

#pragma mark -
#pragma mark accessor methods (in pairs)

@property LGOMSize cellsSize;

#pragma mark -
#pragma mark Utility methods

- (void)   gameBoardSetup:(NSString* _Nonnull)inNewLifeGameBoard;

@end
